/****** amiga.lib/CreateExtIO **************************************/
/*
  Copyright (c) 1988 Commodore-Amiga, Inc.
 
  Executables based on this information may be used in software
  for Commodore Amiga computers.  All other rights reserved.
 
  This information is provided "as is"; no warranties are made.
  All use is at your own risk, and no liability or responsibility is assumed.
*/


#include "exec/types.h"
#include "exec/memory.h"
#include "exec/io.h"
/*
#include "proto/exec.h"
#include "functions.h"
*/


struct IORequest *CreateExtIO( ioReplyPort, size )
struct MsgPort *ioReplyPort;
ULONG  size;
{
struct IORequest *ioReq;

    if(! ioReplyPort )
	return(NULL);

    ioReq =
	 (struct IORequest *)AllocMem( size, (ULONG)MEMF_CLEAR|MEMF_PUBLIC );

    if(!ioReq)
	return(NULL);

    ioReq->io_Message.mn_Node.ln_Type = NT_MESSAGE;
    ioReq->io_Message.mn_Length       = size;	/* save for later */
    ioReq->io_Message.mn_ReplyPort    = ioReplyPort;

    return( ioReq );
}


/****** amiga.lib/DeleteExtIO **************************************/

void DeleteExtIO( ioExt )
struct IORequest *ioExt;
{
    /* try to make it hard to reuse the request by accident */
    ioExt->io_Message.mn_Node.ln_Type = -1;
    ioExt->io_Message.mn_ReplyPort    = (struct MsgPort *)-1;
    ioExt->io_Device		      = (struct Device *) -1;

    FreeMem( ioExt, (ULONG)ioExt->io_Message.mn_Length );
}
